// RunTestSet.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <tchar.h>
#include <iostream.h>
#include <string.h>
#include <afxdisp.h>
#import "C:\Program Files\Common Files\Mercury Interactive\QualityCenter 9.0\QCClientUI.ocx" raw_interfaces_only, raw_native_types, no_namespace, named_guids 
#import "C:\Program Files\Common Files\Mercury Interactive\QualityCenter 9.0\OTAClient.dll" no_namespace, named_guids 


_bstr_t szServer;
_bstr_t szDomain;
_bstr_t szProject;
_bstr_t szUser;
_bstr_t szPassword;
_bstr_t szTestSet;
_bstr_t szTestSetPath;
_bstr_t szHost;
_bstr_t szHostGroup;
_bstr_t szMailUser;
_bstr_t SZ_NONE(_T(""));

//added by Puneet
ITDConnectionPtr sp_tdcon;

ITestSetPtr tsf;
bool *tsexst;

void SendExecEmail(ITSSchedulerPtr sch, char *testCaseID, int emailType)
{
	_bstr_t LogStatus(sch->GetExecutionLog());
	CString mStatus((LPCTSTR) LogStatus);
	CString cServer((LPCTSTR) szServer);
	CString cDomain((LPCTSTR) szDomain);
	CString cProject((LPCTSTR) szProject);
	CString cUser((LPCTSTR) szUser);
	CString cTestSetPath((LPCTSTR) szTestSetPath);
	CString cTestSet((LPCTSTR) szTestSet);
	CString cTest((LPCTSTR) testCaseID);

	IBaseFactoryPtr tststf = tsf->GetTSTestFactory();
	ITSTestPtr tstst = tststf->GetItem(testCaseID);
	
	COleDateTime CurDate = sp_tdcon->GetServerTime();
	CString MsgBody="";
	if(emailType==1)
		MsgBody += "<HTML><BODY>Test <font color=\"#0000FF\">" + tstst->Name + "</font> in test set <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font> has failed!<p><p>";
	else if(emailType==3)
		//MsgBody += "<HTML><BODY>Environmental failure has occurred during execution of test <font color=\"#0000FF\">" + tstst->Name + "</font>!<p><p>";
		MsgBody += "<HTML><BODY>Environmental failure has occurred during execution of test <font color=\"#0000FF\">" + tstst->Name + "</font> on host <font color=\"#0000FF\">" + sch->GetTdHostName() + "</font>!<p><p>";

	IExecEventNotifyByMailSettingsPtr spMS= tsf->GetExecEventNotifyByMailSettings();
	CString userMessage((LPCTSTR) spMS->UserMessage);
	if (((LPCTSTR)spMS->UserMessage)!="") MsgBody += userMessage + "<p>Details<BR>---------------------------------<p>";

	MsgBody += "Server: <font color=\"#0000FF\">" + cServer + "</font><p>";
	MsgBody += "Domain: <font color=\"#0000FF\">" + cDomain + "</font><p>";
	MsgBody += "Project: <font color=\"#0000FF\">" + cProject + "</font><p>";
	MsgBody += "User: <font color=\"#0000FF\">" + cUser + "</font><p>";
	MsgBody += "Test set: <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font><p>";
	MsgBody += "Test : <font color=\"#0000FF\">" + tstst->Name + " (id: " + cTest + ")</font><p>";
	
	MsgBody += "Host : <font color=\"#0000FF\">" + sch->GetTdHostName()  + "</font><p>";
	
	MsgBody += "Completion Date: <font color=\"#0000FF\">" + CurDate.Format(VAR_DATEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
	MsgBody += "Completion Time: <font color=\"#0000FF\">" + CurDate.Format(VAR_TIMEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
	MsgBody += "<html><style>";
	MsgBody += "h1 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; font-weight: normal; color: navy;}";
	MsgBody += "h2 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
	MsgBody += "tr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; vertical-align: top}";
	MsgBody += "td { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray}";
	MsgBody += "hr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
	MsgBody += "body { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000;}";
	MsgBody += "table { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray;}";
	MsgBody += "</style><head>";
	MsgBody += "<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">";
	MsgBody += "<title>Execution Report</title>";
	MsgBody += "</head><body bgcolor=\"seashell\"><center>";
	MsgBody += "<h1>Execution Report</h1>";
	MsgBody += "<table width=\"100%\" cellPadding=\"4\" cellSpacing=\"0\" align=\"center\" style=\"border-width=1pt\">";
	MsgBody += "<tr bgcolor=\"gray\">";
	MsgBody += "<td style=\"	color: Yellow\"><b>Plan: Test Name</b></td>";
	MsgBody += "<td style=\"	color: Yellow\"><b>Status</b></td>";
	MsgBody += "<td style=\"	color: Yellow\"><b>Responsible Tester</b></td>";
	MsgBody += "<td style=\"	color: Yellow\"><b>Tester</b></td>";
	MsgBody += "<td style=\"	color: Yellow\"><b>Exec Date</b></td>";
	MsgBody += "<td style=\"	color: Yellow\"><b>Time</b></td></tr>";
	//IBaseFactoryPtr tststf = tsf->GetTSTestFactory();
	IListPtr spList = tststf->NewList("");
	int i;
	for(i=1; i<=spList->GetCount(); i++)
	{
		if(i % 2 > 0)
		{
			MsgBody += "<tr bgcolor=\"papayawhip\">";
		}
		else
		{
			MsgBody += "<tr bgcolor=\"seashell\">";
		}
		//ITSTestPtr 
		tstst = spList->GetItem(i).pdispVal;
		MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + tstst->GetName() + "</td>";
		CString tStatus = (LPCTSTR) tstst->GetStatus();
		if(tStatus=="Failed") 
		{
			MsgBody += "<td style=\"color: Red;border-top-width: 1pt; border-right-width: 1pt;\">Failed</td>";
		}
		else
		{
			if(tStatus =="Passed")
			{
				MsgBody += "<td style=\"color: Green;border-top-width: 1pt; border-right-width: 1pt;\">Passed</td>";
			}
			else
			{
				MsgBody += "<td style=\"color: Tomato;border-top-width: 1pt; border-right-width: 1pt;\">" + tStatus + "</td>";
			}
		}
		_bstr_t tTester = (_bstr_t) tstst->GetField("TC_TESTER_NAME");
		_bstr_t tExecDate = (_bstr_t) tstst->GetField("TC_EXEC_DATE");
		_bstr_t tExecTime = (_bstr_t) tstst->GetField("TC_EXEC_TIME");
		CString cTester = (LPCTSTR) tTester;
		CString cExecDate = (LPCTSTR) tExecDate;
		CString cExecTime = (LPCTSTR) tExecTime;
		if (cTester.IsEmpty())
		{
			MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">&nbsp;</td>";
		}
		else
		{
			MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cTester + "</td>";
		}
		MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + szUser + "</td>";
		MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecDate + "</td>";
		MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecTime + "</td></tr>";
	}
	MsgBody += "</table></center></body></html></BODY></HTML>";
	_variant_t vv;
	vv.vt=VT_NULL;
	CString Subject("<<Execution Event Notification>>");
	sp_tdcon->SendMail(szMailUser,"admin",(LPCTSTR) Subject,(LPCTSTR) MsgBody,vv,"HTML");
}

void ProcessExecStatus(ITSSchedulerPtr spScheduler)
{
	int i;
	IExecutionStatusPtr exst = spScheduler->ExecutionStatus;
	ITestExecStatusPtr tes;

	exst->RefreshExecStatusInfo(_T(""), VARIANT_TRUE);
	
    for(i=1;i<=exst->Count;i++)
	{
		if(tsexst[i]==false)
		{
	        tes = exst->GetItem(i).pdispVal;
			//printf("YES %d %s %s\n", tsexst[i], (LPCTSTR)tes->Status, "Error");
			if(strcmp((LPCTSTR)tes->Status,"Error")==0)
            {
				//send an Environmental Failure error
				_bstr_t sttemp1(tes->GetTSTestId());
				printf("Environmental failure in Test %s\n",(LPCTSTR) sttemp1);
				if (szMailUser!=SZ_NONE) SendExecEmail(spScheduler,(char*) sttemp1, 3);
				tsexst[i] = true;
			}
			else if(strcmp((LPCTSTR)tes->Status,"FinishedFailed")==0)
			{
				//send an Failure error
				_bstr_t sttemp1(tes->GetTSTestId());
				printf("Test %s failed, sending email.\n", (LPCTSTR) sttemp1);
				if (szMailUser!=SZ_NONE) SendExecEmail(spScheduler,(char*) sttemp1, 1);
				tsexst[i] = true;
			}
			//else if(strcmp(tes->Status,"FinishedPassed")==0) tsexst[i] = true;
        }
	}
}


void RunTestSet(bool runLocally)
{
	try
	{
		// establish connection to OTA server
		//ITDConnectionPtr sp_tdcon;
		sp_tdcon.CreateInstance(CLSID_TDConnection);
		printf("Initializing TDServer %s\n",(LPCTSTR)szServer);
		sp_tdcon->InitConnectionEx(szServer);
		printf("Connecting to %s.%s project\n",(LPCTSTR)szDomain,(LPCTSTR)szProject);
		sp_tdcon->ConnectProjectEx(szDomain,szProject,szUser,szPassword);

		// get TestSet by path+name
		ITestSetTreeManagerPtr ttree;
		ITestSetFolderPtr tsfolder;
		//mosdify by ayfeng
		ITestSetFactoryPtr tsFact;
		ITestSetPtr ts;

		if (szTestSet.length() != 0)
		{
		//Original 
		ttree = sp_tdcon->GetTestSetTreeManager();
		printf("Checking TestSet : %s\\%s\n",(LPCTSTR)szTestSetPath,(LPCTSTR)szTestSet);
		tsfolder = ttree->GetNodeByPath(szTestSetPath);
		IListPtr spList = tsfolder->FindTestSets(szTestSet, FALSE, "");

		long nCount = spList->Count;
		if (nCount == 0) 
		{
			cout << _T("Error: Specified TestSet does not exist.") << endl;
			return;
		}

			for (int i=1; i<= spList->GetCount(); i++) 
			{
				ITestSetPtr spTestSet = spList->GetItem(i).pdispVal;
				CString cTestSet1((LPCTSTR) szTestSet);
				CString cListTestSet((LPCTSTR) spTestSet->GetName());
				cListTestSet.MakeUpper();
				cTestSet1.MakeUpper();
				if (cListTestSet!= cTestSet1)
				{
					break;
				}

				IExecEventNotifyByMailSettingsPtr spMS= spTestSet->GetExecEventNotifyByMailSettings();
				spMS->PutEnabled(2,VARIANT_TRUE);
				HRESULT rc=spMS->Save(VARIANT_TRUE);


				printf("Opening Scheduler...\n");
				// get scheduler
				ITSSchedulerPtr spScheduler = spTestSet->StartExecution(_T(""));

				// setup hosr and hostgroup if needed
				if (runLocally)
				{
					spScheduler->RunAllLocally = VARIANT_TRUE;
				}
				else if (szHostGroup.length() != 0)
				{
		//			spScheduler->RunAllLocally = VARIANT_FALSE;
		/*			IBaseFactoryPtr spTSFactory = spTestSet->TSTestFactory;
					spList = spTSFactory->NewList(_T(""));
					for (long i = 1; i <= spList->Count; i++)
					{
						ITSTestPtr spTSTest = spList->GetItem(i).pdispVal;
						spScheduler->RunOnHost[spTSTest->ID.lVal] = szHostGroup;
					}*/

					printf("Running on host group %s\n",(char*)szHostGroup);
					spScheduler->PutTdHostName(szHostGroup);
				}
				else if (szHost.length() != 0)
				{
					printf("Running on host %s\n",(char*)szHost);
					spScheduler->PutTdHostName(szHost);
				}
				else
				{
					spScheduler->RunAllLocally = VARIANT_FALSE;
				}


				printf("Starting test set execution...\n");
				// start TestSet execution
				spScheduler->Run(_T("SELECT TC_TEST_ID FROM TEST,TESTCYCL WHERE TS_TEST_ID=TC_TEST_ID AND TS_TYPE<>'MANUAL' ORDER BY TC_TEST_ORDER"));

				// get execution status, until "Finished"
				IExecutionStatusPtr spExecStatus = spScheduler->ExecutionStatus;
				
				tsf = spTestSet;
				spExecStatus->RefreshExecStatusInfo(_T(""), VARIANT_TRUE);
				tsexst = new bool[spExecStatus->GetCount()];
				int statusCounter;
				for(statusCounter=0;statusCounter<spExecStatus->GetCount();statusCounter++)
					tsexst[statusCounter]=false;

				while(!spExecStatus->Finished) 
				{
    				Sleep(10000);
					spExecStatus->RefreshExecStatusInfo(_T(""), VARIANT_TRUE);	//VARIANT_FALSE);
					ProcessExecStatus(spScheduler);
				   //			printf("    Running Status : %s",(LPCTSTR)spExecStatus->GetItem(spExecStatus->GetCount()).bstrVal);
				} // end while loop
				ProcessExecStatus(spScheduler);
				delete []tsexst;
				printf("Run finished\n",szMailUser);

				if (szMailUser!=SZ_NONE)
				{
					//Gerry's code
					_bstr_t LogStatus(spScheduler->GetExecutionLog());
					CString mStatus((LPCTSTR) LogStatus);
					CString cServer((LPCTSTR) szServer);
					CString cDomain((LPCTSTR) szDomain);
					CString cProject((LPCTSTR) szProject);
					CString cUser((LPCTSTR) szUser);
					CString cTestSetPath((LPCTSTR) szTestSetPath);
					CString cTestSet((LPCTSTR) szTestSet);

					COleDateTime CurDate = sp_tdcon->GetServerTime();
					CString MsgBody = "<HTML><BODY>Test set <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font> of project <font color=\"#0000FF\">" + cProject + "</font> in domain <font color=\"#0000FF\">" + cDomain + "</font> completed!<p><p>";
					MsgBody += "Server: <font color=\"#0000FF\">" + cServer + "</font><p>";
					MsgBody += "Domain: <font color=\"#0000FF\">" + cDomain + "</font><p>";
					MsgBody += "Project: <font color=\"#0000FF\">" + cProject + "</font><p>";
					MsgBody += "User: <font color=\"#0000FF\">" + cUser + "</font><p>";
					MsgBody += "Test set: <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font><p>";
					MsgBody += "Completion Date: <font color=\"#0000FF\">" + CurDate.Format(VAR_DATEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
					MsgBody += "Completion Time: <font color=\"#0000FF\">" + CurDate.Format(VAR_TIMEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
					MsgBody += "<html><style>";
					MsgBody += "h1 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; font-weight: normal; color: navy;}";
					MsgBody += "h2 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
					MsgBody += "tr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; vertical-align: top}";
					MsgBody += "td { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray}";
					MsgBody += "hr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
					MsgBody += "body { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000;}";
					MsgBody += "table { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray;}";
					MsgBody += "</style><head>";
					MsgBody += "<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">";
					MsgBody += "<title>Execution Report</title>";
					MsgBody += "</head><body bgcolor=\"seashell\"><center>";
					MsgBody += "<h1>Execution Report</h1>";
					MsgBody += "<table width=\"100%\" cellPadding=\"4\" cellSpacing=\"0\" align=\"center\" style=\"border-width=1pt\">";
					MsgBody += "<tr bgcolor=\"gray\">";
					MsgBody += "<td style=\"	color: Yellow\"><b>Plan: Test Name</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Status</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Responsible Tester</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Tester</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Exec Date</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Time</b></td></tr>";
					IBaseFactoryPtr tststf = spTestSet->GetTSTestFactory();
					IListPtr spList = tststf->NewList("");
					int i;
					for(i=1; i<=spList->GetCount(); i++)
					{
						if(i % 2 > 0)
						{
							MsgBody += "<tr bgcolor=\"papayawhip\">";
						}
						else
						{
							MsgBody += "<tr bgcolor=\"seashell\">";
						}
						ITSTestPtr tstst = spList->GetItem(i).pdispVal;
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + tstst->GetName() + "</td>";
						CString tStatus = (LPCTSTR) tstst->GetStatus();
						if(tStatus=="Failed") 
						{
							MsgBody += "<td style=\"color: Red;border-top-width: 1pt; border-right-width: 1pt;\">Failed</td>";
						}
						else
						{
							if(tStatus =="Passed")
							{
								MsgBody += "<td style=\"color: Green;border-top-width: 1pt; border-right-width: 1pt;\">Passed</td>";
							}
							else
							{
								MsgBody += "<td style=\"color: Tomato;border-top-width: 1pt; border-right-width: 1pt;\">" + tStatus + "</td>";
							}
						}
						_bstr_t tTester = (_bstr_t) tstst->GetField("TC_TESTER_NAME");
						_bstr_t tExecDate = (_bstr_t) tstst->GetField("TC_EXEC_DATE");
						_bstr_t tExecTime = (_bstr_t) tstst->GetField("TC_EXEC_TIME");
						CString cTester = (LPCTSTR) tTester;
						CString cExecDate = (LPCTSTR) tExecDate;
						CString cExecTime = (LPCTSTR) tExecTime;
						if (cTester.IsEmpty())
						{
							MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">&nbsp;</td>";
						}
						else
						{
							MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cTester + "</td>";
						}
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + szUser + "</td>";
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecDate + "</td>";
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecTime + "</td></tr>";
					}
					MsgBody += "</table></center></body></html></BODY></HTML>";
					_variant_t vv;
					vv.vt=VT_NULL;
					CString Subject("<<Execution Event Notification>>");
					sp_tdcon->SendMail(szMailUser,"admin",(LPCTSTR) Subject,(LPCTSTR) MsgBody,vv,"HTML");
					//End Gerrys code
				}
				printf("Finished test set execution ...\n");	
			}//end for loop
		}
		else
		{

		//modify by ayfeng
		ttree = sp_tdcon->GetTestSetTreeManager();
		printf("Checking TestSetFolder : %s\n",(LPCTSTR)szTestSetPath);
		tsfolder = ttree->GetNodeByPath(szTestSetPath);		
		tsFact = tsfolder->GetTestSetFactory();
		IListPtr spList = tsFact->NewList("");

		long nCount = spList->Count;
		if (nCount == 0) 
		{
			cout << _T("Error: There is no test set found.") << endl;
			return;
		}

			for (int i=1; i<= spList->GetCount(); i++) 
			{
				ITestSetPtr spTestSet = spList->GetItem(i).pdispVal;
				
				_variant_t tsID;
				_bstr_t szTestSet;
				tsID = spTestSet->GetID();
				szTestSet = spTestSet->GetName();

				_bstr_t mytsID = (_bstr_t) tsID;

				IExecEventNotifyByMailSettingsPtr spMS= spTestSet->GetExecEventNotifyByMailSettings();
				spMS->PutEnabled(2,VARIANT_TRUE);
				HRESULT rc=spMS->Save(VARIANT_TRUE);


				printf("Opening Scheduler...\n");
				// get scheduler
				ITSSchedulerPtr spScheduler = spTestSet->StartExecution(_T(""));

				// setup hosr and hostgroup if needed
				if (runLocally)
				{
					spScheduler->RunAllLocally = VARIANT_TRUE;
				}
				else if (szHostGroup.length() != 0)
				{
		//			spScheduler->RunAllLocally = VARIANT_FALSE;
		/*			IBaseFactoryPtr spTSFactory = spTestSet->TSTestFactory;
					spList = spTSFactory->NewList(_T(""));
					for (long i = 1; i <= spList->Count; i++)
					{
						ITSTestPtr spTSTest = spList->GetItem(i).pdispVal;
						spScheduler->RunOnHost[spTSTest->ID.lVal] = szHostGroup;
					}*/

					printf("Running on host group %s\n",(char*)szHostGroup);
					spScheduler->PutTdHostName(szHostGroup);
				}
				else if (szHost.length() != 0)
				{
					printf("Running on host %s\n",(char*)szHost);
					spScheduler->PutTdHostName(szHost);
				}
				else
				{
					spScheduler->RunAllLocally = VARIANT_FALSE;
				}


				printf("Starting test set execution...\n");
				// start TestSet execution
				spScheduler->Run(_T("SELECT TC_TEST_ID FROM TEST,TESTCYCL WHERE TS_TEST_ID=TC_TEST_ID AND TS_TYPE<>'MANUAL' AND TC_CYCLE_ID =" + mytsID));

				// get execution status, until "Finished"
				IExecutionStatusPtr spExecStatus = spScheduler->ExecutionStatus;

				tsf = spTestSet;
				spExecStatus->RefreshExecStatusInfo(_T(""), VARIANT_TRUE);
				tsexst = new bool[spExecStatus->GetCount()];

				int statusCounter;
				for(statusCounter=0;statusCounter<spExecStatus->GetCount();statusCounter++)
					tsexst[statusCounter]=false;

				while(!spExecStatus->Finished) 
				{
    				Sleep(10000);
					spExecStatus->RefreshExecStatusInfo(_T(""), VARIANT_FALSE);
					ProcessExecStatus(spScheduler);
				} // end while loop
				ProcessExecStatus(spScheduler);
				delete []tsexst;
				printf("Run finished\n",szMailUser);

				if (szMailUser!=SZ_NONE)
				{
					//Gerry's code
					_bstr_t LogStatus(spScheduler->GetExecutionLog());
					CString mStatus((LPCTSTR) LogStatus);
					CString cServer((LPCTSTR) szServer);
					CString cDomain((LPCTSTR) szDomain);
					CString cProject((LPCTSTR) szProject);
					CString cUser((LPCTSTR) szUser);
					CString cTestSetPath((LPCTSTR) szTestSetPath);
					CString cTestSet((LPCTSTR) spTestSet->GetName());

					COleDateTime CurDate = sp_tdcon->GetServerTime();
					CString MsgBody = "<HTML><BODY>Test set <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font> of project <font color=\"#0000FF\">" + cProject + "</font> in domain <font color=\"#0000FF\">" + cDomain + "</font> completed!<p><p>";
					MsgBody += "Server: <font color=\"#0000FF\">" + cServer + "</font><p>";
					MsgBody += "Domain: <font color=\"#0000FF\">" + cDomain + "</font><p>";
					MsgBody += "Project: <font color=\"#0000FF\">" + cProject + "</font><p>";
					MsgBody += "User: <font color=\"#0000FF\">" + cUser + "</font><p>";
					MsgBody += "Test set: <font color=\"#0000FF\">" + cTestSetPath + "\\" + cTestSet + "</font><p>";
					MsgBody += "Completion Date: <font color=\"#0000FF\">" + CurDate.Format(VAR_DATEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
					MsgBody += "Completion Time: <font color=\"#0000FF\">" + CurDate.Format(VAR_TIMEVALUEONLY,LANG_USER_DEFAULT) + "</font><p>";
					MsgBody += "<html><style>";
					MsgBody += "h1 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; font-weight: normal; color: navy;}";
					MsgBody += "h2 { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
					MsgBody += "tr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; vertical-align: top}";
					MsgBody += "td { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray}";
					MsgBody += "hr { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: navy;}";
					MsgBody += "body { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000;}";
					MsgBody += "table { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-weight: normal; color: #000000; border: 0 solid dimgray;}";
					MsgBody += "</style><head>";
					MsgBody += "<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">";
					MsgBody += "<title>Execution Report</title>";
					MsgBody += "</head><body bgcolor=\"seashell\"><center>";
					MsgBody += "<h1>Execution Report</h1>";
					MsgBody += "<table width=\"100%\" cellPadding=\"4\" cellSpacing=\"0\" align=\"center\" style=\"border-width=1pt\">";
					MsgBody += "<tr bgcolor=\"gray\">";
					MsgBody += "<td style=\"	color: Yellow\"><b>Plan: Test Name</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Status</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Responsible Tester</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Tester</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Exec Date</b></td>";
					MsgBody += "<td style=\"	color: Yellow\"><b>Time</b></td></tr>";
					IBaseFactoryPtr tststf = spTestSet->GetTSTestFactory();
					IListPtr spList = tststf->NewList("");
					int i;
					for(i=1; i<=spList->GetCount(); i++)
					{
						if(i % 2 > 0)
						{
							MsgBody += "<tr bgcolor=\"papayawhip\">";
						}
						else
						{
							MsgBody += "<tr bgcolor=\"seashell\">";
						}
						ITSTestPtr tstst = spList->GetItem(i).pdispVal;
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + tstst->GetName() + "</td>";
						CString tStatus = (LPCTSTR) tstst->GetStatus();
						if(tStatus=="Failed") 
						{
							MsgBody += "<td style=\"color: Red;border-top-width: 1pt; border-right-width: 1pt;\">Failed</td>";
						}
						else
						{
							if(tStatus =="Passed")
							{
								MsgBody += "<td style=\"color: Green;border-top-width: 1pt; border-right-width: 1pt;\">Passed</td>";
							}
							else
							{
								MsgBody += "<td style=\"color: Tomato;border-top-width: 1pt; border-right-width: 1pt;\">" + tStatus + "</td>";
							}
						}
						_bstr_t tTester = (_bstr_t) tstst->GetField("TC_TESTER_NAME");
						_bstr_t tExecDate = (_bstr_t) tstst->GetField("TC_EXEC_DATE");
						_bstr_t tExecTime = (_bstr_t) tstst->GetField("TC_EXEC_TIME");
						CString cTester = (LPCTSTR) tTester;
						CString cExecDate = (LPCTSTR) tExecDate;
						CString cExecTime = (LPCTSTR) tExecTime;
						if (cTester.IsEmpty())
						{
							MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">&nbsp;</td>";
						}
						else
						{
							MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cTester + "</td>";
						}
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + szUser + "</td>";
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecDate + "</td>";
						MsgBody += "<td style=\"border-top-width: 1pt; border-right-width: 1pt;\">" + cExecTime + "</td></tr>";
					}
					MsgBody += "</table></center></body></html></BODY></HTML>";
					_variant_t vv;
					vv.vt=VT_NULL;
					CString Subject("<<Execution Event Notification>>");
					sp_tdcon->SendMail(szMailUser,"admin",(LPCTSTR) Subject,(LPCTSTR) MsgBody,vv,"HTML");
					//End Gerrys code
				}
				printf("Finished test set execution ...\n");	
			}//end for loop
		}
		
		printf("Disconnecting from TD\n");
		// free OTA server connection 
		sp_tdcon->DisconnectProject();
		sp_tdcon->ReleaseConnection();
	}
	catch(_com_error& err)
	{
		try
		{
			cout << _T("Error: ") << static_cast<LPCTSTR>(err.Description()) << endl;
		}
		catch(...)
		{
			cout << _T("Error: ") << static_cast<LPCTSTR>(err.ErrorMessage()) << endl;
		}
	}
	catch(...)
	{
		cout << _T("Error: Unexpected error.") << endl;
	}
}


int main(int argc, char* argv[])
{
	// initialize MUST parameters
	szServer = SZ_NONE;
	szDomain = SZ_NONE;
	szProject = SZ_NONE;
	szUser = SZ_NONE;
	szTestSetPath = SZ_NONE;
	szMailUser=SZ_NONE;

	// parse parameters
	if (argc == 2) // show help
	{
		if (_tcsicmp(argv[1], _T("/?")) == 0) 
		{
			cout << _T("Executes a TestDirector TestSet.") << endl << endl;
			cout << _T("RunTestSet /s:Server /n:Domain /d:Project /u:user [/p:password] /t:testset [/f:Root\TestsetFolder\TestsetSubFolder] [/l]|[/h:host]|[/g:hostgroup]") << endl << endl;
			cout << _T("\tEx.  RunTestSet /s:http://Servername/tdbin /n:Default /d:TestDirector_Demo /u:admin /p:password /l /m:admin") <<endl;
			cout << _T("\t/s - TestDirector server") << endl;
			cout << _T("\t/n - TestDirector domain") << endl;
			cout << _T("\t/d - TestDirector project name") << endl;
			cout << _T("\t/u - user name") << endl;
			cout << _T("\t/p - user password [optional]") << endl;
			cout << _T("\t/t - TestSet name[optional]") << endl;
			cout << _T("\t/f - TestSet Folder Path") << endl;
			cout << _T("\t/l - run locally [optional]") << endl;
			cout << _T("\t/h - host name [optional]") << endl;
			cout << _T("\t/g - host group name [optional]") << endl;
			cout << _T("\t/m - User Name who will receive a notification mail if the TestSet Failed [optional]") << endl;
			cout << _T("\t/? - help") << endl;
		}
		else
  			cout << _T("Error: ") << argv[1] << _T("is invalid parameter.") << endl;
	}
	else if (argc > 4) // run test set
	{
		CoInitialize(NULL);
		bool runLocally = false;
		for (int i = 1; i < argc; i++)
		{
			char flag[4];
			memset(flag, 0, 4);
			_tcsncpy(flag, argv[i], 3);
			if (_tcsicmp(flag, _T("/s:")) == 0)
			{
				szServer = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/n:")) == 0)
			{
				szDomain = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/d:")) == 0)
			{
				szProject = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/u:")) == 0)
			{
				szUser = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/p:")) == 0)
			{
				szPassword = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/t:")) == 0)
			{
				szTestSet = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/l")) == 0)
			{
				runLocally = true;
			}
			else if (_tcsicmp(flag, _T("/h:")) == 0)
			{
				szHost = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/g:")) == 0)
			{
				szHostGroup = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/m:")) == 0)
			{
				szMailUser = argv[i] + 3;
			}
			else if (_tcsicmp(flag, _T("/f:")) == 0)
			{
				szTestSetPath = argv[i] + 3;
			}
			else
			{
				cout << _T("Error: ") << argv[i] << _T("is invalid parameter.") << endl;
				return -1;
			}
		}

		// check MUST parameters
		if (szServer == SZ_NONE)
		{
			cout << _T("Error: ") << _T("missing server name.") << endl;
			return -1;
		}
		if (szDomain == SZ_NONE)
		{
			cout << _T("Error: ") << _T("missing domain name.") << endl;
			return -1;
		}
		if (szProject == SZ_NONE)
		{
			cout << _T("Error: ") << _T("missing project name.") << endl;
			return -1;
		}
		if (szUser == SZ_NONE)
		{
			cout << _T("Error: ") << _T("missing user name.") << endl;
			return -1;
		}
		if (szTestSetPath == SZ_NONE)
		{
			cout << _T("Error: ") << _T("missing testset folder name.") << endl;
			return -1;
		}

		// run TestSet
		RunTestSet(runLocally);



		CoUninitialize();
	}
	else
		cout << _T("Error: wrong number of parameters.") << endl;

	return 0;
}

